pipeline {
    agent any
    tools {
      go 'go'
    }
    environment {
        CGO_ENABLED = 0 
        GOPATH = "${JENKINS_HOME}/jobs/${JOB_NAME}/builds/${BUILD_ID}"
    }
    stages { 
        // stage('clone') {
        //     steps {
        //         checkout([$class: 'GitSCM',
        //         branches: [[name: '*/master' ]],
        //         extensions: scm.extensions,
        //         userRemoteConfigs: [[
        //             url: 'git@gitlab.com:rajeswar.khan/samplego.git',
        //             credentialsId: 'rajeswar.khan'
        //         ]]
        //     ])
        //     }
        // }
                 stage('SCM') {
    steps{
        checkout scm
    }
  }
        stage('Pre Test') {
            steps {
                echo 'Installing dependencies'
                sh 'go version'                
                sh 'go get -u golang.org/x/lint/golint'
            }
        }
        
        stage('Build') {
            steps {
                echo 'Compiling and building'
                sh 'go build'
            }
        }

        stage('Test') {
            steps {
                withEnv(["PATH+GO=${GOPATH}/bin"]){
                    echo 'Running vetting'
                    sh 'go vet .'
                    // echo 'Running linting'
                    // sh 'golint .'
                    echo 'Running test'
                    sh 'go test -v'
                }
            }
        }
 
  stage('SonarQube Analysis') {
    hygieiaBuildPublishStep buildStatus: 'Success'
   steps{
       script {
          // requires SonarQube Scanner 2.8+
          scannerHome = tool 'SonarScanner'
        }         
        withSonarQubeEnv('SonarDocker') {
        sh "${scannerHome}/bin/sonar-scanner"
        }
   }
  }


    
 
 
}
}
